using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_Aplicacion.Visualizacion;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_KairosPRO;
using Exferia_KairosPRO._2_Datos;
using Exferia_KairosPRO._4_Vistas;
using Exferia_KairosPRO.General;
using Exferia_KairosPRO_EF;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;

namespace Test
{
    public partial class Form1 : Form
    {
        private string g_str_RUTA = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location) + @"\XML_DatosPrueba.xml";
        private string g_str_idUsuario = "";

        public Form1()
        {
            InitializeComponent();

            if (!File.Exists(g_str_RUTA))
            {
                CrearXML();
            }
            else
            {
                Cargar_ValoresXML();

                lbl_Servidor.Text = Variables.G_STR_CONEXION_SERVIDOR;
                lbl_BaseDatos.Text = Variables.G_STR_CONEXION_BASEDATOS;
                lbl_Perfil.Text = g_str_idUsuario;

            }                

            
           /* Variables.G_STR_CONEXION_SERVIDOR_KAIROSPRO = @"EXFERIA01-X64\MSSQL";
            Variables.G_STR_CONEXION_BASEDATOS_KAIROSPRO = "KairosPro";
            Variables.G_STR_CONEXION_USUARIO_KAIROSPRO = "";
            Variables.G_STR_CONEXION_CLAVE_KAIROSPRO = "";*/


            Variables.G_STR_LIBRERIA_RUTAINICIAL = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location);
            
            //Variables.G_STR_CONEXION_SERVIDOR_KAIROSPRO = @"DESARROLLO-A\SQLEXPRESS_2019";
            //Variables.G_STR_CONEXION_SERVIDOR_KAIROSPRO = @"DESARROLLO-A\DESARROLLO_A_14";
            Variables.G_STR_CONEXION_SERVIDOR_KAIROSPRO = @"DESARROLLO-A\SQLEXPRESS_2019";
            Variables.G_STR_CONEXION_BASEDATOS_KAIROSPRO = "KairosPro";
            Variables.G_STR_CONEXION_USUARIO_KAIROSPRO = "sa";
            Variables.G_STR_CONEXION_CLAVE_KAIROSPRO = "SQL_Exferia";
            

            //Asignar Colores de Exferia ..................................................................
            Colores.G_COLOR_FONDO_BOTON = Color.Transparent;
            Colores.G_COLOR_PRINCIPAL_BASE = ColorTranslator.FromHtml("#A19CC3");
            Colores.G_COLOR_PRINCIPAL_OSCURO = ColorTranslator.FromHtml("#504888");
            Colores.G_COLOR_PRINCIPAL_ATENUADO = ColorTranslator.FromHtml("#CBC8DF");
            Colores.G_COLOR_PRINCIPAL_CLARO = ColorTranslator.FromHtml("#EDECF4");
            Colores.G_COLOR_PRINCIPAL_TRASLUCIDO = Color.FromArgb(50, 191, 186, 225);
            Colores.G_COLOR_SECUNDARIO_BASE = ColorTranslator.FromHtml("#FFF2C4");
            Colores.G_COLOR_SECUNDARIO_CLARO = ColorTranslator.FromHtml("#FFF9E1");
            Colores.G_COLOR_FONDO_BASE = ColorTranslator.FromHtml("#FFFFFF");
            Colores.G_COLOR_TEXTO_ESCRITO = ColorTranslator.FromHtml("#000000");
            Colores.G_COLOR_ATENCION = ColorTranslator.FromHtml("#c40909");
            Colores.G_COLOR_KAIROSPRO_FICHAJE_BORDE_CELDA = ColorTranslator.FromHtml("#A19CC3");

            Colores.G_COLOR_FONDO_BARRAPROGRESO_RELLENA = ColorTranslator.FromHtml("#504888");

            //Listados
            Colores.G_COLOR_LISTADO_FILTROS = Color.FromArgb(50, 161, 156, 195);
            Colores.G_COLOR_LISTADO_FILTROS_CONTROLESPERSONALIZADOS = Color.FromArgb(70, 161, 156, 195);

           
            //Usuario Validado .......................................................
            /*INTERNO_UsuarioValidado_Modelo mdl_INTERNO_UsuarioValidado_Modelo = new INTERNO_UsuarioValidado_Modelo();
            mdl_INTERNO_UsuarioValidado_Modelo.id = long.Parse(g_str_idUsuario != "" ? g_str_idUsuario : "0");//410
            mdl_INTERNO_UsuarioValidado_Modelo.idPerfil = null;
            mdl_INTERNO_UsuarioValidado_Modelo.nombre = "EXFERIA";
            mdl_INTERNO_UsuarioValidado_Modelo.sincronizacionAthos = false;
            mdl_INTERNO_UsuarioValidado_Modelo.esSuperUsuario = false;*/

             Datos_Generales.USR_Usuarios_Cargar(long.Parse(g_str_idUsuario != "" ? g_str_idUsuario : "0")); 

            //Delegacion
            Variables.G_DTT_FECHA_INICIAL_PORDEFECTO = new DateTime(2022, 01,13);

            Variables.G_MDL_INTERNO_VALORESGENERALES_MODELO = null;
            INTERNO_ValoresGenerales_Modelo mdl_INTERNO_ValoresGenerales_Modelo = Datos_Generales.GEN_ValoresGenerales_Obtener_Por_IdUsuario(Variables.G_MDL_USUARIOVALIDADO_MODELO.id);
            if (mdl_INTERNO_ValoresGenerales_Modelo != null)
            {
                mdl_INTERNO_ValoresGenerales_Modelo = Datos_Generales.GEN_EjerciciosActivos_Empresa_Validar(mdl_INTERNO_ValoresGenerales_Modelo, Variables.G_DTT_FECHA_INICIAL_PORDEFECTO);
                if (mdl_INTERNO_ValoresGenerales_Modelo != null)
                {
                    Variables.G_MDL_INTERNO_VALORESGENERALES_MODELO = mdl_INTERNO_ValoresGenerales_Modelo;
                }
            }

            //Variable con el codigo del cliente de la ExferiaStore
            Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO = 100;// 74;

            //LISTADO DE RUTAS Cargamos el ensamblado #########################################################################################################################################################################
            Assembly m_assembly_1 = Assembly.LoadFrom(@"C:\Proyectos\Visual Studio 2015\Projects\DLL" + @"\" + Variables.G_STR_LIBRERIA_INFORMES + ".dll");
            //Assembly m_assembly_1 = Assembly.LoadFrom(@"C:\Users\Exferia\Documents\Visual Studio 2015\Projects\DLL" + @"\" + Variables.G_STR_LIBRERIA_INFORMES + ".dll");
            //Obtenemos el tipo de la clase
            Type m_type_1 = m_assembly_1.GetType("" + Variables.G_STR_LIBRERIA_INFORMES + "." + Variables.G_STR_LIBRERIA_DATOSINFORMES);
            //creamos la instancia
            var obj_Clase_1 = Activator.CreateInstance(m_type_1);
            //Cargamos el metodo solicitado
            MethodInfo obj_MethodInfo_1 = obj_Clase_1.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSINFORMES_PROCEDIMIENTO_INFRUTAS_RELLENARLISTADO, BindingFlags.Instance | BindingFlags.NonPublic);

            //Obtener valores
            object[] arr_Parametros_1 = { };

            obj_MethodInfo_1.Invoke(obj_Clase_1, arr_Parametros_1);
            //##############################################################################################################################################################################################

            //Cargar XML Configuracion pantallas
            Funciones_FicherosXML.CargarDatosXML_ConfiguracionPantallas();

            Datos_Generales.PRV_OpcionesDetalle_Cargar();

            Repintar.Empezar(this);

            Variables.G_SPL_PANTALLASPRINCIPAL = spl_Principal;
            Variables.G_PNL_PANTALLASEMPOTRADAS = spl_Principal.Panel1;
            Variables.G_PNL_PANTALLASEMPOTRADAS_SECUNDARIA = spl_Principal.Panel2;
            Variables.G_EMS_CONTROL_MENUSUPERIOR = ex_msp_Menu;

            Funciones_PanelSecundario.Rellenar_Listados_ArbolSecundarioSeleccion();

            //calcular distancia del splitter
            spl_Principal.SplitterDistance = this.Width / 2;
            spl_Principal.Panel2Collapsed = true;

            Datos_Generales.Permisos_Cargar();
        }

        #region Botones
        private void btn_Abrir_Listado_Click(object sender, EventArgs e)
        {
            string str_NombreLibreria = txt_Listado_Libreria.Text;
            string str_Opcion = cbo_Listado_Opcion.Text;

            if (str_Opcion != "")
            { 
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + str_NombreLibreria + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(str_NombreLibreria + "." + Variables.G_STR_LIBRERIA_OPCIONES);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_OPCIONES_PROCEDIMIENTO_CARGAR_LISTADO, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { str_Opcion, false, 0, null, Variables.G_MDL_INTERNO_VALORESGENERALES_MODELO, Variables.G_DTT_FECHA_INICIAL_PORDEFECTO, "", "", false, false, null, null, null,null,null,null };
                //Pasamos los parametros al metodo y lo ejecutamos
                obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
        }

        private void btn_Abrir_Mantenimiento_Click(object sender, EventArgs e)
        {
            string str_NombreLibreria = txt_Mantenimiento_Libreria.Text;
            string str_Opcion = cbo_Mantenimiento_Opcion.Text;

            INTERNO_OpcionesDetalle_Modelo mdl_INTERNO_OpcionesDetalle_Modelo = Datos_Generales.PRV_Opciones_Buscar_Detalles(str_Opcion);
            
            //Cargamos el ensamblado
            Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + str_NombreLibreria + ".dll");
            //Obtenemos el tipo de la clase
            Type m_type = m_assembly.GetType(str_NombreLibreria + "." + Variables.G_STR_LIBRERIA_OPCIONES);
            //creamos la instancia
            var obj_Clase = Activator.CreateInstance(m_type);
            //Cargamos el metodo solicitado
            MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_OPCIONES_PROCEDIMIENTO_MOSTRAR_EN_MANTENIMIENTO, BindingFlags.Instance | BindingFlags.NonPublic);

            object[] arr_Parametros = { str_Opcion,
                                        null,
                                        null,
                                        Variables.G_MDL_INTERNO_VALORESGENERALES_MODELO,
                                        Variables.G_DTT_FECHA_INICIAL_PORDEFECTO,
                                        mdl_INTERNO_OpcionesDetalle_Modelo,
                                        102638,
                                        "",
                                        "",
                                       null,
                                        null};
            //Pasamos los parametros al metodo y lo ejecutamos
            obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
        }

        private void btn_CodigoPrueba_Click(object sender, EventArgs e)
        {
            Datos_KairosPRO obj = new Datos_KairosPRO();

           // obj.Obtener_HorasTrabajadas_EXTERNA(new DateTime(2022, 3, 1,0,0,0), new DateTime(2022, 3, 8,23,59,59),24, 100);
            //INTERNO_OpcionesDetalle_Modelo mdl_INTERNO_OpcionesDetalle_Modelo = Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_COM_DEVOLUCIONPAGO);

            //P_FichajesAutomaticos g_frm = new P_FichajesAutomaticos(Variables.G_MDL_INTERNO_VALORESGENERALES_MODELO, Variables.G_DTT_FECHA_INICIAL_PORDEFECTO, mdl_INTERNO_OpcionesDetalle_Modelo);
            //Funciones_PanelPrincipal.Cargar_PantallaEmpotrada(g_frm, Variables.G_STR_OPCION_COM_DEVOLUCIONPAGO);

            /*Verificacion_Fichajes obj_Verificacion_Fichajes = new Verificacion_Fichajes();

            //Cargar los valores de los Diccionarios
            Verificacion_Fichajes_Diccionarios.Vaciar_Diccionarios();
            Verificacion_Fichajes_Diccionarios.Cargar_Diccionarios(37);
            

            KRS_Empleados_Datos obj_ = new KRS_Empleados_Datos();
            KRS_Empleados mdl_KRS_Empleados =obj_.Obtener_Modelo_Por_Id(420, 37, false, false);
            obj_Verificacion_Fichajes.Proceso(37,new DateTime(2020,03,30,08, 15,0), mdl_KRS_Empleados,true,65);
            */

            /* DateTime dtt_Prueba = new DateTime(2019,1,30,22,0,0);

             KRS_Empleados_Negocio obj_KRS_Empleados_Negocio = new KRS_Empleados_Negocio();
             KRS_Empleados _mdl_KRS_Empleados = obj_KRS_Empleados_Negocio.Obtener_Simple(424);

             Verificacion_Fichajes obj_Verificacion_Fichajes = new Verificacion_Fichajes();
             obj_Verificacion_Fichajes.Proceso(Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO, dtt_Prueba, _mdl_KRS_Empleados, false);*/



            /* Verificacion_Fichaje_EnvioEmail obj = new Verificacion_Fichaje_EnvioEmail();
             obj.Fichajes_Invalidos(Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO);*/
            /*//Buscar Listado
            //Cargamos el ensamblado
            Assembly obj_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\Exferia_KairosPRO.dll");
            //Obtenemos el tipo de la clase
            Type obj_type = obj_assembly.GetType("Exferia_KairosPRO.Datos_KairosPRO");
            //creamos la instancia
            var obj_clase = Activator.CreateInstance(obj_type);
            //Cargamos el metodo solicitado
            MethodInfo m = obj_clase.GetType().GetMethod("Empleado_InsertarActualizar_1", BindingFlags.Instance | BindingFlags.NonPublic);

            MAE_Empleados _mdl_MAE_Empleados = new MAE_Empleados();
            _mdl_MAE_Empleados.id = 1;
            _mdl_MAE_Empleados.dni = "78563966Z";
            object[] arr_parametros = { _mdl_MAE_Empleados, true,null,true};

            //Pasamos los parametros al metodo y lo ejecutamos
             List<INTERNO_Listado_Simple_Modelo> g_lst_INTERNO_Listado_Simple_Modelo = (List<INTERNO_Listado_Simple_Modelo>)m.Invoke(obj_clase, arr_parametros);*/
        }

        private void btn_CambiarConexion_Click(object sender, EventArgs e)
        {
            AbrirPantallaConexion();
        }
        #endregion

        private void CrearXML()
        {
            FileStream fls_CrearFichero = null;
            try
            {
                //Creamos el fichero
                fls_CrearFichero = new FileStream(g_str_RUTA, FileMode.Create);

                fls_CrearFichero.Close();

                //Ahora crearemos la estructura del XML
                XmlDocument Documento = new XmlDocument();
                XmlNode xn_Declaration = Documento.CreateXmlDeclaration("1.0", "UTF-8", "yes");
                Documento.AppendChild(xn_Declaration);
                //Nodo Padre
                XmlNode xn_NodoPrincipal = Documento.CreateElement("Datos");
                Documento.AppendChild(xn_NodoPrincipal);
                //Nodos Hijos
                XmlNode xn_Servidor = Documento.CreateElement("servidor");
                XmlNode xn_BaseDatos = Documento.CreateElement("basedatos");
                XmlNode xn_Usuario = Documento.CreateElement("usuario");
                XmlNode xn_Clave = Documento.CreateElement("clave");
                XmlNode xn_Perfil = Documento.CreateElement("idusuario");

                xn_NodoPrincipal.AppendChild(xn_Servidor);
                xn_NodoPrincipal.AppendChild(xn_BaseDatos);
                xn_NodoPrincipal.AppendChild(xn_Usuario);
                xn_NodoPrincipal.AppendChild(xn_Clave);
                xn_NodoPrincipal.AppendChild(xn_Perfil);

                Documento.Save(g_str_RUTA);

                AbrirPantallaConexion();
            }
            catch (Exception)
            {

            }
        }

        private void Cargar_ValoresXML()
        {
            XmlDocument Documento = new XmlDocument();
            Documento.Load(g_str_RUTA);

            //Nodo principal 
            XmlNode obj_NodoPadre = Documento.GetElementsByTagName("Datos")[0];

            Variables.G_STR_CONEXION_SERVIDOR = obj_NodoPadre["servidor"].InnerText;
            Variables.G_STR_CONEXION_BASEDATOS = obj_NodoPadre["basedatos"].InnerText;
            Variables.G_STR_CONEXION_USUARIO = obj_NodoPadre["usuario"].InnerText;
            Variables.G_STR_CONEXION_CLAVE = obj_NodoPadre["clave"].InnerText;
            g_str_idUsuario = obj_NodoPadre["idusuario"].InnerText;

            if (Variables.G_STR_CONEXION_SERVIDOR.Equals("") || g_str_idUsuario.Equals(""))
            {
                AbrirPantallaConexion();
            }
        }

        private void AbrirPantallaConexion()
        {
            Form2 frm_Conexion = new Form2(Variables.G_STR_CONEXION_SERVIDOR, Variables.G_STR_CONEXION_BASEDATOS, Variables.G_STR_CONEXION_USUARIO, Variables.G_STR_CONEXION_CLAVE, g_str_idUsuario);
            frm_Conexion.StartPosition = FormStartPosition.CenterParent;
            frm_Conexion.ShowDialog();
        }
    }
}
